<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html"></xsl:output>
	<xsl:template match="/Java_Perf_Advisor">
		<html>
			<link rel="stylesheet" type="text/css" href="style.css" />
			<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
			<head>
				<title>AIX Java Performance Advisor</title>
				<!-- This is for popup -->
				<script type="text/javascript" src="popup.js"></script>
			</head>
			<body>
				<TABLE cellspacing="0" width="100%" height="30">
					<TBODY>
						<TR height="95px">
							<TD background="images/left_header.png" width="80">
								<IMG src="images/AIX_logo.gif" height="75" />
							</TD>
							<TD background="images/mid_header.png" align="center">
								<FONT face="comic sans ms" size="6" color="white">AIX Java
									Performance Advisor</FONT>
							</TD>
							<TD background="images/right_header.png" width="140">
								<IMG src="images/ibmlogo.gif" height="70" />
							</TD>
						</TR>
					</TBODY>
				</TABLE>
				<table width="100%">
					<tr>
						<td width="10px" rowspan="2" background="images/menu.png"></td>
						<td colspan="2">
							<table>
								<tr>
									<td colspan="2">
										<font size="3">The ratings and recommendations in the table below were chosen with the following information:</font>
									</td>
								</tr>
								<tr>
									<td><xsl:apply-templates select="Performance_Profile" /></td>
									<td><xsl:apply-templates select="Job_Information" /></td>
									<td><xsl:apply-templates select="Trace_Information" /></td>
								</tr>
							</table>
						</td>
						<td width="10px" rowspan="2" background="images/menu.png"></td>
					</tr>
					<tr>
						<td valign="top">
							<xsl:apply-templates select="PerformanceCategory[@Name = 'Hardware']"></xsl:apply-templates>
							<xsl:apply-templates select="PerformanceCategory[@Name = 'AIX']"></xsl:apply-templates>
						</td>
						<td valign="top">
							<xsl:apply-templates select="PerformanceCategory[@Name = 'WebSphere']"></xsl:apply-templates>
							<xsl:apply-templates select="PerformanceCategory[@Name = 'Java']"></xsl:apply-templates>
							<br />
						</td>
					</tr>
					<tr height="20">
						<td colspan="4" background="images/menu.png"></td>
					</tr>
				</table>
			</body>
		</html>
	</xsl:template>

	<xsl:template name="ColumnHeaders">
		<tr bgcolor="#E0E0E0">
			<td colspan="2"></td>
			<th>
				<b>Name</b>
			</th>
			<th>
				<b>Current Value</b>
			</th>
			<th>
				<b>Recommended Value</b>
			</th>
			<th>
				<b>Risk</b>
				<br />
				1=lowest
				<br />
				5=highest
			</th>
			<th>
				<b>Impact</b>
				<br />
				1=lowest
				<br />
				5=highest
			</th>
		</tr>
	</xsl:template>

	<xsl:template name="Seperator">
		<tr>
			<td width="100%" colspan="7">
				<hr />
			</td>
		</tr>
	</xsl:template>

	<xsl:template match="Performance_Profile">
		<font size="3">
			<table>
				<xsl:apply-templates select="Profile_Input"></xsl:apply-templates>
			</table>
		</font>
	</xsl:template>

	<xsl:template match="Job_Information">
		<font size="3">
			<b>Process ID : </b><xsl:apply-templates select="PID"></xsl:apply-templates><br/>
			<b>User name : </b><xsl:apply-templates select="User"></xsl:apply-templates><br/>
			<b>Command Line : </b><a href="#CommandLine" onclick="popup('CommandLine'); return false">Show</a>
			<div id="CommandLine" style="display: none; word-wrap:break-word;">
				<p>
					<h3>Command Line :</h3>
					<xsl:apply-templates select="CommandLine"></xsl:apply-templates>
				</p>
			</div>
			<br />
		</font>
	</xsl:template>
	
	<xsl:template match="Trace_Information">
		<font size="3">
			<b>Hostname : </b><xsl:apply-templates select="HostName"></xsl:apply-templates><br/>
			<b>Date Taken : </b><xsl:apply-templates select="DateTaken"></xsl:apply-templates><br/>
			<b>Time Taken : </b><xsl:apply-templates select="TimeTaken"></xsl:apply-templates><br/>
		</font>
	</xsl:template>

	<xsl:template match="Profile_Input">
		<tr>
			<td>
				<a class="hotspot" href='#{generate-id(@Name)}' onclick="popup('{generate-id(@Name)}'); return false">
					<xsl:value-of select="@Name"></xsl:value-of>
				</a>
				<xsl:text> : </xsl:text>
				<div id="{generate-id(@Name)}" style="display: none;">
					<p>
						<h3>Description</h3>
						<xsl:apply-templates select="Description"></xsl:apply-templates>
					</p>
				</div>
			</td>
			<td>
				<b>
					<xsl:value-of select="Admin_Input"></xsl:value-of>
				</b>
			</td>
		</tr>
	</xsl:template>

	<xsl:template match="Description">
		<xsl:copy-of select="." />
	</xsl:template>

	<xsl:template match="PerformanceCategory">
		<table width="100%" border="1" cellpadding="5">
			<xsl:call-template name="Seperator"></xsl:call-template>
			<tr>
				<td bgcolor="black" width="2%"></td>
				<td colspan="6">
					<h3>
						<xsl:apply-templates select="@Name"></xsl:apply-templates>
					</h3>
				</td>
			</tr>
			<xsl:call-template name="ColumnHeaders"></xsl:call-template>
			<xsl:apply-templates select="PerfValue"></xsl:apply-templates>
		</table>
	</xsl:template>

	<xsl:template name="unit">
		<xsl:param name="value" />
		<xsl:variable name="val" select="$value"></xsl:variable>
		<xsl:choose>
			<xsl:when test="@unit = 'GB' and $val &lt; 1">
				<xsl:value-of select="$val * 1024"></xsl:value-of>
				<xsl:text> MB</xsl:text>
			</xsl:when>
			<xsl:when test="@unit = 'MB and $val &lt; 1'">
				<xsl:value-of select="$val * 1024"></xsl:value-of>
				<xsl:text> KB</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$val"></xsl:value-of>
				<xsl:text> </xsl:text>
				<xsl:value-of select="@unit"></xsl:value-of>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template match="PerfValue">
		<xsl:choose>
			<xsl:when test="@Hidden='Y'">
				<!-- do nothing if its a hidden metric -->
			</xsl:when>
			<xsl:when test="@Hidden='U'">
				<!-- display with background -->
				<tr onclick="popup('{generate-id(@Name)}'); return false" onmouseover="this.style.cursor='pointer'" bgcolor="Wheat">
					<td bgcolor="black" colspan="2"><img border="0" src="images/readonly.png" align="left" width="25" /></td>
					<td><xsl:value-of select="@Name"></xsl:value-of></td>
					<td><div style="width:150px; word-wrap:break-word;">
						<xsl:call-template name="unit" >
							<xsl:with-param name="value"><xsl:value-of select="CurrentValue"></xsl:value-of></xsl:with-param>
						</xsl:call-template>
					</div></td>
					<td><!--  nothing to recommend --></td>
					<td><xsl:value-of select="Risk"></xsl:value-of></td>
					<td><xsl:value-of select="Impact"></xsl:value-of></td>
				</tr>
				<div id="{generate-id(@Name)}" style="display: none;">
					<p>
						<h3>Why Important? </h3>
						<xsl:apply-templates select="WhyImportant"></xsl:apply-templates>
					</p>
					<br />
					<!--  display this only if not null -->
					<xsl:if test="not(contains(HowToModify,'null'))">
						<p>
							<h3>How To Modify? </h3>
							<xsl:apply-templates select="HowToModify"></xsl:apply-templates>
						</p>
					</xsl:if>
				</div>
			</xsl:when>
			<xsl:otherwise>
				<tr onclick="popup('{generate-id(@Name)}'); return false" onmouseover="this.style.cursor='pointer'">
					<td bgcolor="black" colspan="2">
						<!--  <a class="hotspot" href='#{generate-id(@Name)}' onclick="popup('{generate-id(@Name)}'); return false"> -->
							<xsl:choose>
								<xsl:when test="RecommendedChange='Warning'">
									<img border="0" src="images/Warning_icon.png" title="Possible Performance Issue" align="left" width="25" />
								</xsl:when>
								<xsl:when test="RecommendedChange='Recommendation'">
									<img border="0" src="images/red-error.gif" title="Severe Performance Issue" align="left" width="25" />
								</xsl:when>
								<xsl:when test="RecommendedChange='Good'">
									<img border="0" src="images/correct.png" title="Value is acceptable in most cases" align="left" width="25" />
								</xsl:when>
								<xsl:when test="RecommendedChange='Investigate'">
									<img border="0" title="Investigation is required. Click here for details" src="images/investigate.gif" align="left" width="25" />
								</xsl:when>
								<xsl:otherwise>
									<img border="0" src="images/readonly.png" align="left"
										width="25" />
								</xsl:otherwise>
							</xsl:choose>
						<!-- </a>-->
					</td>
					<td>
						<xsl:value-of select="@Name"></xsl:value-of>
					</td>
					<td>
						<div style="width:150px; word-wrap:break-word;">
							<xsl:call-template name="unit" >
								<xsl:with-param name="value"><xsl:value-of select="CurrentValue"></xsl:value-of></xsl:with-param>
							</xsl:call-template>
						</div>
					</td>
					<td>
						<div style="width:150px; word-wrap:break-word;">
							<xsl:choose>
								<xsl:when test="RecommendedValue != ''">
									<xsl:call-template name="unit">
										<xsl:with-param name="value"><xsl:value-of select="RecommendedValue"></xsl:value-of></xsl:with-param>
									</xsl:call-template>
								</xsl:when>
								<xsl:when test="MinRecommendedValue != ''">
									<xsl:choose>
										<xsl:when test="MaxRecommendedValue = 'NoMax'">
											<xsl:text>>= </xsl:text>
											<xsl:call-template name="unit">
												<xsl:with-param name="value"><xsl:value-of select="MinRecommendedValue"></xsl:value-of></xsl:with-param>
											</xsl:call-template>
										</xsl:when>
										<xsl:otherwise>
											<xsl:call-template name="unit">
												<xsl:with-param name="value"><xsl:value-of select="MinRecommendedValue"></xsl:value-of></xsl:with-param>
											</xsl:call-template>
											<xsl:text> to </xsl:text>
											<xsl:call-template name="unit">
												<xsl:with-param name="value"><xsl:value-of select="MaxRecommendedValue"></xsl:value-of></xsl:with-param>
											</xsl:call-template>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:when>
							</xsl:choose>
						</div>
					</td>
					<td>
						<xsl:value-of select="Risk"></xsl:value-of>
					</td>
					<td>
						<xsl:value-of select="Impact"></xsl:value-of>
					</td>
				</tr>
				<div id="{generate-id(@Name)}" style="display: none;">
					<p>
						<h3>Why Important? </h3>
						<xsl:apply-templates select="WhyImportant"></xsl:apply-templates>
					</p>
					<br />
					<!--  display this only if not null -->
					<xsl:if test="not(contains(HowToModify,'null'))">
						<p>
							<h3>How To Modify? </h3>
							<xsl:apply-templates select="HowToModify"></xsl:apply-templates>
						</p>
					</xsl:if>
				</div>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="WhyImportant">
		<xsl:copy-of select="." />
	</xsl:template>

	<xsl:template match="HowToModify">
		<xsl:copy-of select="." />
	</xsl:template>

</xsl:stylesheet>
